﻿#region << 版 本 注 释 >>
/*----------------------------------------------------------------
* 项目名称 ：ClassAttendanceStatistics.Models
* 项目描述 ：
* 类 名 称 ：ClassItem
* 类 描 述 ：
* 所在的域 ：DESKTOP-MNML8TD
* 命名空间 ：ClassAttendanceStatistics.Models
* 机器名称 ：DESKTOP-MNML8TD 
* CLR 版本 ：4.0.30319.42000
* 作    者 ：栾凤杰
* 创建时间 ：2018/9/7 11:27:53
* 更新时间 ：2018/9/7 11:27:53
* 版 本 号 ：v1.0.0.0
*******************************************************************
* Copyright @ 青岛通软网络有限公司 2018. All rights reserved.
*******************************************************************
//----------------------------------------------------------------*/
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GalaSoft.MvvmLight;

namespace ClassAttendanceStatistics.Model
{
    /// <summary>
    /// 本班详细
    /// </summary>
    public class ClassItem : ObservableObject
    {
        private Guid _ClassID;
        /// <summary>
        /// 班级ID
        /// </summary>
        public Guid ClassID
        {
            get { return _ClassID; }
            set { _ClassID = value; RaisePropertyChanged("ClassID"); }
        }

        private string _ClassName;
        /// <summary>
        /// 班级名称
        /// </summary>
        public string ClassName
        {
            get { return _ClassName; }
            set { _ClassName = value; RaisePropertyChanged("ClassName"); }
        }

        private int _ShiDao;
        /// <summary>
        /// 实到人数
        /// </summary>
        public int ShiDao
        {
            get { return _ShiDao; }
            set { _ShiDao = value; RaisePropertyChanged("ShiDao"); }
        }

        private int _YingDao;
        /// <summary>
        /// 应到人数
        /// </summary>
        public int YingDao
        {
            get { return _YingDao; }
            set { _YingDao = value; RaisePropertyChanged("YingDao"); }
        }

        private int _QingJia;
        /// <summary>
        /// 请假人数
        /// </summary>
        public int QingJia
        {
            get { return _QingJia; }
            set { _QingJia = value; RaisePropertyChanged("QingJia"); }
        }

        private int _WeiDao;
        /// <summary>
        /// 未到人数
        /// </summary>
        public int WeiDao
        {
            get { return _WeiDao; }
            set { _WeiDao = value; RaisePropertyChanged("WeiDao"); }
        }

        private int _ChiDao;
        /// <summary>
        /// 迟到人数
        /// </summary>
        public int ChiDao
        {
            get { return _ChiDao; }
            set { _ChiDao = value; RaisePropertyChanged("ChiDao"); }
        }

        private int _MianQian;
        /// <summary>
        /// 免签人数
        /// </summary>
        public int MianQian
        {
            get { return _MianQian; }
            set { _MianQian = value; RaisePropertyChanged("MianQian"); }
        }     
        
        /// <summary>
        /// 将数据模型打包为视图模型
        /// </summary>
        /// <param name="resp"></param>
        /// <returns></returns>
        public static explicit operator ClassItem(ResponseModel.ClassItem resp)
        {
            var classItem = new ClassItem();

            classItem.ClassID = resp.ClassId;
            classItem.ClassName = resp.ClassName;
            classItem.ShiDao = resp.ShiDao;
            classItem.YingDao = resp.YingDao;
            classItem.QingJia = resp.QingJia;
            classItem.WeiDao = resp.WeiDao;
            classItem.ChiDao = resp.ChiDao;
            classItem.MianQian = resp.MianQian;

            return classItem;
        }
    }
}
