﻿#region << 版 本 注 释 >>
/*----------------------------------------------------------------
* 项目名称 ：ClassAttendanceStatistics.Models
* 项目描述 ：
* 类 名 称 ：ClassList
* 类 描 述 ：
* 所在的域 ：DESKTOP-MNML8TD
* 命名空间 ：ClassAttendanceStatistics.Models
* 机器名称 ：DESKTOP-MNML8TD 
* CLR 版本 ：4.0.30319.42000
* 作    者 ：栾凤杰
* 创建时间 ：2018/9/7 13:17:37
* 更新时间 ：2018/9/7 13:17:37
* 版 本 号 ：v1.0.0.0
*******************************************************************
* Copyright @ 青岛通软网络有限公司 2018. All rights reserved.
*******************************************************************
//----------------------------------------------------------------*/
#endregion

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GalaSoft.MvvmLight;

namespace ClassAttendanceStatistics.Model
{
    /// <summary>
    /// 某节课的班级列表
    /// </summary>
    public class LessonInfo : ObservableObject
    {
        /// <summary>
        /// 打卡时间
        /// </summary>
        public string LessonTime
        {            
            get
            {
                if (KQStartTime != null || KQEndTime != null)
                {
                    return $"打卡 {KQStartTime} {KQEndTime}";
                }
                else
                {
                    return string.Empty;
                }
            }
        }

        private string _CourseName;
        /// <summary>
        /// 课程名称
        /// </summary>
        public string CourseName
        {
            get { return _CourseName; }
            set { _CourseName = value; RaisePropertyChanged("CourseName"); }
        }

        private string _KQStartTime;
        /// <summary>
        /// 考勤开始时间
        /// </summary>
        public string KQStartTime
        {
            get { return _KQStartTime; }
            set { _KQStartTime = value; RaisePropertyChanged("KQStartTime"); RaisePropertyChanged("LessonTime"); }
        }

        private string _KQEndTime;
        /// <summary>
        /// 考勤结束时间
        /// </summary>
        public string KQEndTime
        {
            get { return _KQEndTime; }
            set { _KQEndTime = value; RaisePropertyChanged("KQEndTime"); RaisePropertyChanged("LessonTime"); }
        }

        private string _PublishTime;
        /// <summary>
        /// 课程发布时间
        /// </summary>
        public string PublishTime
        {
            get { return _PublishTime; }
            set { _PublishTime = value; RaisePropertyChanged("PublishTime"); }
        }

        private ObservableCollection<ClassItem> _ClassList;
        /// <summary>
        /// 班级的集合
        /// </summary>

        public ObservableCollection<ClassItem> ClassList
        {
            get { return _ClassList; }
            set { _ClassList = value; RaisePropertyChanged("ClassList"); }
        }

        private bool _IsSelected;

        public bool IsSelected
        {
            get { return _IsSelected; }
            set { _IsSelected = value; RaisePropertyChanged("IsSelected"); }
        }


        /// <summary>
        /// 将数据模型打包为视图模型
        /// </summary>
        /// <param name="resp"></param>
        /// <returns></returns>
        public static explicit operator LessonInfo(ResponseModel.ResponseModel resp)
        {
            var lessonInfo = new LessonInfo();
            lessonInfo.CourseName = resp.CourseName;
            lessonInfo.KQStartTime = resp.KQStartTime;
            lessonInfo.KQEndTime = resp.KQEndTime;
            lessonInfo.PublishTime = resp.PublishTime.ToString("发布时间 yyyy-MM-dd HH:mm");
            lessonInfo.ClassList = new ObservableCollection<ClassItem>();
            resp.CLassList.ForEach((s) =>
            {
                lessonInfo.ClassList.Add((ClassItem)s);
            });

            return lessonInfo;
        }
    }
}
