﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DashBoard.ServiceModel
{
    /// <summary>
    /// 学生对象，包含学生、最后打卡记录以及进出状态（在校状态）
    /// </summary>
    public class Student
    {
        /// <summary>
        /// 打卡编号
        /// </summary>
        public int ID { get; set; }
        /// <summary>
        /// 学生编号
        /// </summary>
        public int StudentID { get; set; }
        /// <summary>
        /// 学生姓名
        /// </summary>
        public string StudentName { get; set; }
        /// <summary>
        /// 最后打卡时间
        /// </summary>
        public DateTime RecordTime { get; set; }
        /// <summary>
        /// 学生状态
        /// </summary>
        public StateEnum StudentState { get; set; }

        /// <summary>
        /// 是否在校
        /// </summary>
        public bool InSchool { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
    }
    /// <summary>
    /// 在校情况
    /// </summary>
    public enum StateEnum
    {
        正常,
        离校,
        请假,
        异常
    }
}
