﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DashBoard.ServiceModel
{
    /// <summary>
    /// 房间对象
    /// </summary>
    public class Room
    {
        /// <summary>
        /// 房间ID
        /// </summary>
        public int RoomID { get; set; }
        /// <summary>
        /// 房间名称
        /// </summary>
        public string RoomName { get; set; }
        /// <summary>
        /// 房间时间段
        /// </summary>
        public List<TimeSlot> slot { get; set; }
    }
    public class TimeSlot
    {
        /// <summary>
        /// 预约时间段ID
        /// </summary>
        public string DayTimeID { get; set; }
        /// <summary>
        /// 预约时间段
        /// </summary>
        public string DayTime { get; set; }
        /// <summary>
        /// 是否可预约，true可预约false不可预约
        /// </summary>
        public bool IsTrue { get; set; }
        /// <summary>
        /// 预约信息
        /// </summary>
        public Order order { get; set; }
    }
    /// <summary>
    /// 预约信息
    /// </summary>
    public class Order
    {
        /// <summary>
        /// 预约ID
        /// </summary>
        public int ID { get; set; }
        /// <summary>
        /// 预约房间ID
        /// </summary>
        public int OrderRoomID { get; set; }
        /// <summary>
        /// 预约房间名称
        /// </summary>
        public string OrderRoomName { get; set; }
        /// <summary>
        /// 预约人ID
        /// </summary>
        public string OrderUserID { get; set; }
        /// <summary>
        /// 预约人姓名
        /// </summary>
        public string OrderUserName { get; set; }
        /// <summary>
        /// 审核状态
        /// </summary>
        public OrderTypeEnum OrderType { get; set; }
        /// <summary>
        /// 预约日期
        /// </summary>
        public DateTime OrderStartTime { get; set; }
        /// <summary>
        /// 星期几
        /// </summary>
        public DayOfWeek WeedDay { get; set; }
        /// <summary>
        /// 预约时间段ID
        /// </summary>
        public string DayTimeID { get; set; }
        /// <summary>
        /// 预约时间段
        /// </summary>
        public string DayTime { get; set; }
        /// <summary>
        /// 预约事由
        /// </summary>
        public string Reason { get; set; }

    }
    /// <summary>
    /// 审核状态0待审核1已审核预约通过2已审核预约未通过3超时自动取消
    /// </summary>
    public enum OrderTypeEnum
    {
        待审核 = 0,
        已预约 = 1,
        未预约 = 2,
        超时取消 = 3,
    }
}
