﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DashBoard.ServiceModel
{
    // <summary>
    /// 学生在校状况
    /// </summary>
    public class School_StudentState
    {
        /// <summary>
        /// 全校学生数
        /// </summary>
        public int StudentCount
        {
            get
            {
                var total = GaoYi?.Total + GaoEr?.Total + GaoSan?.Total;
                return total.HasValue ? total.Value : 0;
            }
        }
        /// <summary>
        /// 在校学生数
        /// </summary>
        public int InCount
        {
            get
            {
                var total = GaoYi?.In + GaoEr?.In + GaoSan?.In;
                return total.HasValue ? total.Value : 0;
            }
        }
        /// <summary>
        /// 离校学生数
        /// </summary>
        public int OutCount
        {
            get
            {
                var total = GaoYi?.Out + GaoEr?.Out + GaoSan?.Out;
                return total.HasValue ? total.Value : 0;
            }
        }
        /// <summary>
        /// 请假学生数
        /// </summary>
        public int LeaveCount
        {
            get
            {
                var total = GaoYi?.Leave + GaoEr?.Leave + GaoSan?.Leave;
                return total.HasValue ? total.Value : 0;
            }
        }
        /// <summary>
        /// 高一
        /// </summary>
        public Grade GaoYi { get; set; }
        /// <summary>
        /// 高二
        /// </summary>
        public Grade GaoEr { get; set; }
        /// <summary>
        /// 高三
        /// </summary>
        public Grade GaoSan { get; set; }
    }
    /// <summary>
    /// 级部
    /// </summary>
    public class Grade
    {
        /// <summary>
        /// 级部ID
        /// </summary>
        public Guid ID { get; set; }
        /// <summary>
        /// 级部ID
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 级部总人数
        /// </summary>
        public int Total { get; set; }
        /// <summary>
        /// 在校人数
        /// </summary>
        public int In { get; set; }
        /// <summary>
        /// 离校人数
        /// </summary>
        public int Out { get; set; }
        /// <summary>
        /// 请假人数
        /// </summary>
        public int Leave { get; set; }
        /// <summary>
        /// 班级列表
        /// </summary>
        public List<Class> ClassList { get; set; } = new List<Class>();
    }
    /// <summary>
    /// 班级
    /// </summary>
    public class Class
    {
        /// <summary>
        /// 班级ID
        /// </summary>
        public Guid ClassID { get; set; }
        /// <summary>
        /// 班级名称
        /// </summary>
        public string ClassName { get; set; }
        /// <summary>
        /// 级部总人数
        /// </summary>
        public int Total { get; set; }
        /// <summary>
        /// 在校人数
        /// </summary>
        public int In { get; set; }
        /// <summary>
        /// 离校人数
        /// </summary>
        public int Out { get; set; }
        /// <summary>
        /// 请假人数
        /// </summary>
        public int Leave { get; set; }
    }
}
