﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GS.Terminal.DashBoard.Interface
{
    /// <summary>
    /// 用来描述一个页面
    /// </summary>
    public interface IDashBoardPage : ICloneable, IDisposable
    {
        /// <summary>
        /// 页面固定ID
        /// </summary>
        Guid PageID { get; }
        /// <summary>
        /// 主界面上菜单项的图标
        /// </summary>
        Uri Icon { get; }
        /// <summary>
        /// 页面标题
        /// </summary>
        string Title { get; }
        /// <summary>
        /// 页面自己处理viewmodel的绑定
        /// </summary>
        /// <returns>页面的viewmodel</returns>
        PageViewModel BindDataContext();
    }
}
