﻿using GS.Terminal.Common.WebService;
using GS.Unitive.Framework.Core;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Cryptography;
using System.Security.Policy;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GS.Terminal.DashBoard.Interface
{
    public class Tools
    {
        private static WebServiceCenter _webServiceCenter;

        static Tools()
        {
            if (!Directory.Exists(CacheDirectory))
            {
                Directory.CreateDirectory(CacheDirectory);
            }
            _webServiceCenter = new WebServiceCenter(AddonRuntime.Instance.LogWriter, string.Empty, string.Empty);
        }
        private static readonly string DefaultUserAgent = "GS.Terminal.DashBoard";
        private static string CacheDirectory = Path.Combine(Application.StartupPath, "cache", "dashboard");

        [Obsolete("新组件请直接使用WebServiceCenter.Post进行服务请求")]
        public static bool Get<T>(Uri uri, out T entity)
        {
            entity = default(T);
            var result = Get(uri, out string backData);
            if (result)
            {
                entity = JsonConvert.DeserializeObject<T>(backData);
            }
            return result;
        }

        /// <summary>
        /// 发送HTTP GET请求
        /// </summary>
        /// <param name="url"></param>
        /// <param name="result"></param>
        /// <returns></returns>
        [Obsolete("新组件请直接使用WebServiceCenter.Post进行服务请求")]
        public static bool Get(Uri url, out string result)
        {
            result = _webServiceCenter.Post(url, new { }, out bool haserror);
            #region 由于新系统返回的结果被result包裹，为了兼容老的组件，这里过滤掉result
            if (!haserror)
            {
                if (result.StartsWith("{\"result\":"))
                {
                    result = result.Replace("{\"result\":", "");
                    result = result.Remove(result.Length - 1);
                }

            }
            #endregion
            return !haserror;
            try
            {
                HttpWebRequest request = WebRequest.Create(url) as HttpWebRequest;
                request.ProtocolVersion = HttpVersion.Version10;
                //request.Timeout = 1000 * 10;
                request.Method = "GET";
                request.ContentType = "text/html; charset=utf-8";
                request.UserAgent = DefaultUserAgent;


                var response = request.GetResponse() as HttpWebResponse;
                using (var stream = response.GetResponseStream())
                {
                    StreamReader _ResponseStream = new StreamReader(stream);
                    result = _ResponseStream.ReadToEnd();
                    stream.Close();
                    _ResponseStream.Close();
                }
                return true;
            }
            catch (Exception ee)
            {
                return false;
            }
        }
        /// <summary>
        /// 将内容写入缓存
        /// </summary>
        /// <param name="file">要存储的文件名称</param>
        /// <param name="content">要写入的文件内容</param>
        /// <returns>当缓存内容与要写入的内容一致时返回False，不一致时返回True</returns>
        public static bool WriteCache(string file, string content)
        {
            var writeResult = false;
            var fileFullPath = Path.Combine(CacheDirectory, file);
            var cacheContent = ReadCache(file);
            var cacheMD5 = GetMD5WithString(cacheContent);
            var newMD5 = GetMD5WithString(content);
            if (!cacheMD5.Equals(newMD5, StringComparison.CurrentCultureIgnoreCase))
            {
                if (!File.Exists(fileFullPath))
                {
                    File.Create(fileFullPath).Dispose();
                }
                using (StreamWriter writer = new StreamWriter(fileFullPath))
                {
                    writer.Write(content);
                    writeResult = true;
                }
            }
            return writeResult;
        }

        /// <summary>
        /// 读取缓存内容
        /// </summary>
        /// <param name="file">文件名称</param>
        /// <returns></returns>
        public static string ReadCache(string file)
        {
            var content = string.Empty;
            var fileFullPath = Path.Combine(CacheDirectory, file);
            if (File.Exists(fileFullPath))
            {
                using (StreamReader reader = new StreamReader(fileFullPath))
                {
                    content = reader.ReadToEnd();
                }
            }
            return content;
        }

        public static string GetMD5WithString(string sDataIn)
        {
            byte[] data = Encoding.GetEncoding("utf-8").GetBytes(sDataIn);
            MD5 md5 = new MD5CryptoServiceProvider();
            byte[] bytes = md5.ComputeHash(data);
            return string.Join("", bytes.Select(ss => ss.ToString("x2")));
        }
    }
}
