﻿using GS.Terminal.DashBoard.Interface;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GS.Terminal.DashBoard.Logic.Core
{
    public class DashBoardFinder
    {
        [ImportMany(typeof(IDashBoardPage))]
        public IDashBoardPage[] DBPs;

        public bool Find()
        {
            try
            {
                var aggregateCatalog = new AggregateCatalog();
                DirectoryCatalog dc = new DirectoryCatalog(Program.addonContext.Addon.Location + "\\DashBoards", "*.dll");
                aggregateCatalog.Catalogs.Add(dc);
                CompositionContainer container = new CompositionContainer(aggregateCatalog);
                container.ComposeParts(this);
                return true;
            }
            catch (Exception ee)
            {
                Program.logger.Error("查找DashBoards出错", ee);
            }

            return false;
        }
    }
}
