﻿using GS.Terminal.LogicShell.Interface;
using GS.Unitive.Framework.Core;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace GS.Terminal.DashBoard.Logic.LogicShell
{
    public class Service
    {
        private IAddonContext _addonContext;
        private IViewHelperService _addonService;
        public Service()
        {
                if (Program.addonContext != null)
                {
                    _addonContext = Program.addonContext;
                    _addonService = _addonContext.GetFirstOrDefaultService<IViewHelperService>("GS.Terminal.LogicShell");
                }
        }

        /// <summary>
        /// 跳转页面
        /// </summary>
        /// <param name="vm"></param>
        public void Show(IViewModel vm)
        {
            Application.Current.Dispatcher.BeginInvoke(new Action(() =>
            {
                _addonService?.ShowView(vm);
            }));

        }
        /// <summary>
        /// 跳转页面并在完成后执行回调
        /// </summary>
        /// <param name="vm"></param>
        /// <param name="callback"></param>
        public void Show(IViewModel vm, Action<object> callback)
        {
            Application.Current.Dispatcher.BeginInvoke(new Action(() =>
            {
                _addonService?.ShowView(vm, callback);
            }));
        }
        /// <summary>
        /// 跳转页面并在跳转完后后delay毫秒后执行回调
        /// </summary>
        /// <param name="vm"></param>
        /// <param name="delay"></param>
        /// <param name="callback"></param>
        public void Show(IViewModel vm, int delay, Action<object> callback)
        {
            Application.Current.Dispatcher.BeginInvoke(new Action(() =>
            {
                _addonService.ShowView(vm, delay, callback);
            }));
        }
        /// <summary>
        /// 获取所有的ViewModel
        /// </summary>
        /// <returns></returns>
        public IList<IViewModel> GetAllViewModel()
        {
            return _addonService?.GetAllViewModel();
        }
    }
}
