﻿using DashBoardViewModel;
using GS.Unitive.Framework.Core;
using GS.Unitive.Framework.Logging;
using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


namespace GS.Terminal.DashBoard.Logic
{
    public class Program : IAddonActivator
    {
        internal static IAddonContext addonContext;
        internal static ILogWriter logger;
        internal static Locator locator;
        internal static LogicShell.Service LogicShellService;
        internal static MainShell.Service MainShellService;
        internal static ThemeAddon.Service ThemeService;
        internal static Core.DashBoardFinder dbf;
        internal static Core.DashBoardCore dbc;
        internal static Setting.TerminalLocalSetting setting;
        public void Start(IAddonContext Context)
        {

            addonContext = Context;
            logger = Context.Logger;
            dbf = new Core.DashBoardFinder();
            AddonRuntime.Instance.onRuntimeCompleted += Instance_onRuntimeCompleted;
        }

        private void Instance_onRuntimeCompleted(object sender)
        {
            setting = new Setting.TerminalLocalSetting();
            locator = new Locator();
            LogicShellService = new LogicShell.Service();
            MainShellService = new MainShell.Service();
            ThemeService = new ThemeAddon.Service();
            if (dbf.Find())
            {
                if (dbf.DBPs != null && dbf.DBPs.Length > 0)
                {
                    dbc = new Core.DashBoardCore(dbf.DBPs);
                    dbc.doView();//加载DashBoard
                }
                else
                {
                    logger.Error($"未找到DashBoard", null);
                }
            }
            else
            {
                logger.Error($"查找DashBoard失败", null);
            }

            locator.Main.TurnSecond = setting.LogicConfig.SwitchViewSecond;
            if (!setting.LogicConfig.ShowMenu)
            {
                /*
                 * 不显示菜单，直接显示内容页面
                 * 隐藏关闭按钮
                 */
                locator.Main.EnableCancelFullScreen = false;
                locator.Main.ShowItem();
            }
            //MainShellService.RegistBackgroundCommand("dashboard", () =>
            //{
            LogicShellService.Show(locator.Main, arg => { dbc?.StartRefresh(); });
            //ThemeService.SetTheme("dashboard");
            //});
        }

        public void Stop(IAddonContext Context)
        {
            addonContext = null;
            logger = null;
        }
    }
}
