﻿using GS.Terminal.DashBoard.Interface;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SchoolSituation.ClassRoomInfo
{
    /// <summary>
    /// ClassRoomInfo.xaml 的交互逻辑
    /// </summary>
    [Export(typeof(IDashBoardPage))]
    public partial class ClassRoomInfo : Page, IDashBoardPage
    {
        public ClassRoomInfo()
        {
            InitializeComponent();
        }

        public Guid PageID => new Guid("dc9537ab-0480-45f0-a309-eec97b9fb734");

        public Uri Icon => new Uri("/SchoolSituation;component/images/icon-classroominfo.png", UriKind.Relative);


        public PageViewModel BindDataContext()
        {
            var vm = new ClassRoomInfoViewModel();
            this.DataContext = vm;
            return vm;
        }

        public object Clone()
        {
            return new ClassRoomInfo() { DataContext = DataContext };
        }

        public void Dispose()
        {
            this.DataContext = null;
        }

        private void s1_ScrollChanged(object sender, ScrollChangedEventArgs e)
        {
            var view = sender as ScrollViewer;
            if (view != null)
            {
                if (view.Name == "s1")
                    s2.ScrollToVerticalOffset(e.VerticalOffset);
                else if (view.Name == "s2")
                    s1.ScrollToVerticalOffset(e.VerticalOffset);

            }
        }
    }
}
