﻿using Develop.Extension.Wpf;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using GS.Terminal.DashBoard.Interface;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace SchoolSituation
{
    public partial class DormInfoViewModel
    {
        private ViewSuShe_PingFen _PingFen;
        public ViewSuShe_PingFen PingFen
        {
            get { return _PingFen; }
            set { _PingFen = value; RaisePropertyChanged("PingFen"); }
        }
        private ObservableCollection<ViewPingFen> _PF;
        public ObservableCollection<ViewPingFen> PF
        {

            get { return _PF; }
            set { _PF = value; RaisePropertyChanged("PF"); }
        }
        private bool _DetailShowing;
        /// <summary>
        /// 详情窗口是否打开
        /// </summary>
        public bool DetailShowing
        {
            get { return _DetailShowing; }
            set
            {
                _DetailShowing = value;
                RaisePropertyChanged("DetailShowing");
            }
        }
        private bool _ShowInSchool = false;

        public bool ShowInSchool
        {
            get { return _ShowInSchool; }
            set
            {
                _ShowInSchool = value;
                ShowList = new ObservableCollection<ViewSuShe_KaoQin>(AllData);
                RaisePropertyChanged("ShowInSchool");
            }
        }
        private string _KQTipMsg;

        public string KQTipMsg
        {
            get { return _KQTipMsg; }
            set { _KQTipMsg = value; RaisePropertyChanged("KQTipMsg"); }
        }
        private string _PFTipMsg;
        public string PFTipMsg
        {
            get { return _PFTipMsg; }
            set { _PFTipMsg = value; RaisePropertyChanged("PFTipMsg"); }
        }
        private List<ViewSuShe_KaoQin> AllData = new List<ViewSuShe_KaoQin>();
        private ObservableCollection<ViewSuShe_KaoQin> _ShowList;

        public ObservableCollection<ViewSuShe_KaoQin> ShowList
        {
            get { return _ShowList ?? (_ShowList = new ObservableCollection<ViewSuShe_KaoQin>()); }
            set
            {
                _ShowList = value;
                if (value.Count == 0)
                    KQTipMsg = "并没有找到任何数据...";
                kqhide = Visibility.Visible;
                Application.Current.Dispatcher.BeginInvoke(new Action(() =>
                {
                    RaisePropertyChanged("ShowList");
                }));
            }
        }

        private bool _CanCloseDetail = true;

        public bool CanCloseDetail
        {
            get { return _CanCloseDetail; }
            set { _CanCloseDetail = value; RaisePropertyChanged("CanCloseDetail"); }
        }

        private Visibility _kqhide;
        public Visibility kqhide
        {
            get { return _kqhide; }
            set { _kqhide = value;RaisePropertyChanged("kqhide"); }
        }
        private Visibility _pfhide;
        public Visibility pfhide
        {
            get { return _pfhide; }
            set { _pfhide = value; RaisePropertyChanged("pfhide"); }
        }

        private void Loaddata(Guid id)
        {
            var serviceUrl = new Uri($"{Source}?DataType=kaoqin&RoomID={id}&NowTime={DateTime.Now.ToString("MM-dd")}");
            Task.Run(() =>
            {
                kqhide = Visibility.Visible;
                KQTipMsg = "正在拉取数据...";
                CanCloseDetail = false;
                var result = Tools.Get(serviceUrl, out List<DashBoard.ServiceModel.SuShe_KaoQin> list);
                if (result)
                {
                    if (list.Count > 0)
                    {
                        ShowList = new ObservableCollection<ViewSuShe_KaoQin>(list.Select(ss => (ViewSuShe_KaoQin)ss).ToList());
                        kqhide = Visibility.Hidden;
                    }
                    else
                    {
                        KQTipMsg = "并没有找到任何数据...";
                        kqhide = Visibility.Visible;
                    }
                }
                else
                {
                    KQTipMsg = "网络好像出现了异常...";
                    kqhide = Visibility.Visible;
                }
            }).ContinueWith(task =>
            {               
                CanCloseDetail = true;
            });
        }
        private void Loaddatapf(Guid  id)
        {
            var serviceUrl = new Uri($"{Source}?DataType=pingfen&RoomID={id}&NowTime={DateTime.Now.ToString("MM-dd")}");
            Task.Run(() =>
            {
                pfhide = Visibility.Visible;
                PFTipMsg = "正在拉取数据...";
                CanCloseDetail = false;
                var result = Tools.Get(serviceUrl, out DashBoard.ServiceModel.SuShe_PingFen pingfen);
                if (result)
                {
                    PingFen = (ViewSuShe_PingFen)pingfen;
                    if (PingFen.msg!=null)
                    {                                               
                        PF = new ObservableCollection<ViewPingFen>(PingFen.msg);
                        pfhide = Visibility.Hidden;
                    }
                    else
                    {
                        PFTipMsg = "并没有找到任何数据...";
                        pfhide = Visibility.Visible;
                    }
                }
                else
                {
                    PFTipMsg = "网络好像出现了异常...";
                    pfhide = Visibility.Visible;
                }
            }).ContinueWith(task =>
            {               
                CanCloseDetail = true;
            });
        }

        private ViewSuShe _SelectedClass;

        public ViewSuShe SelectedClass
        {
            get { return _SelectedClass; }
            set { _SelectedClass = value; RaisePropertyChanged("SelectedClass"); }
        }
        private Guid _dorID;
        public Guid dorID
        {
            get { return _dorID; }
            set { _dorID = value;RaisePropertyChanged("dorID"); }
        }
        public RelayCommand<ViewSuShe> ShowDetailCommand => new RelayCommand<ViewSuShe>(item =>
        {
            if (item != null)
            {
                SelectedClass = item;
                DetailShowing = true;
                dorID = SelectedClass.RoomID;
                if (PF != null)
                    PF.Clear();
                Loaddata(dorID);
                Loaddatapf(dorID);
            }
        });

        public RelayCommand CloseDetailCommand => new RelayCommand(() =>
        {

            DetailShowing = false;
            SelectedClass = null;
            AllData.Clear();
            ShowInSchool = false;
        });
        private Pager _DayPager;

        public Pager DayPager
        {
            get { return _DayPager ?? (_DayPager = new Pager(7)); }
            set { _DayPager = value; RaisePropertyChanged("DayPager"); }
        }


        public DormInfoViewModel()
        {
            DayPager.OnPageChanged += DayPager_OnPageChanged;
            DayPager.TotalData = 28;
        }
        private void DayPager_OnPageChanged(Pager obj)
        {
            Days.Clear();
            DateTime startDate = DateTime.Now.AddDays((obj.PageIndex - 1) * -7);
            for (int i =-6; i<=0; i++)
            {
                Days.Add(new CustomDay(startDate.AddDays(i)));
            }
            SelectDay.Execute(Days[6]);
        }
        private string _Par;
        public string Par
        {
            get { return _Par; }
            set { _Par = value;RaisePropertyChanged("Par"); }
        }
        private string _DateStr;
        public string DateStr
        {
            get { return _DateStr; }
            set { _DateStr = value;RaisePropertyChanged("DateStr"); }
        }
        private string _WeekStr;
        public string WeekStr
        {
            get { return _WeekStr; }
            set { _WeekStr = value;RaisePropertyChanged("WeekStr"); }
        }
        public CustomDay CurrentDay { get; set; }
        public RelayCommand<CustomDay> SelectDay => new RelayCommand<CustomDay>(item =>
        {
            if (!item.IsSelected)
            {
                if (CurrentDay != null) CurrentDay.IsSelected = false;
                item.IsSelected = true;
                CurrentDay = item;
                Guid id = dorID;
                Par = CurrentDay.Date.ToString("MM-dd");
                DateStr = CurrentDay.Date.ToString("yyyy-MM-dd");
                WeekStr = CurrentDay.WeekString;
                if(PF!=null)
                PF.Clear();
                LoadData(id);
                LoadDatapf(id);
            }

        });       
        private bool isfirstkq = true;
        private bool isfirstpf = true;
        public void LoadData(Guid cid)
        {
            if (isfirstkq)
            {
                isfirstkq = false;
                return;
            }
            var serviceUrl = new Uri($"{Source}?DataType=kaoqin&RoomID={cid}&NowTime={Par}");
            
            Task.Run(() =>
            {
                kqhide = Visibility.Visible;
                KQTipMsg = "正在拉取数据...";
                CanCloseDetail = false;
                var result = Tools.Get(serviceUrl, out List<DashBoard.ServiceModel.SuShe_KaoQin> list);
                if (result)
                {
                    if (list.Count > 0)
                    {
                        
                        ShowList = new ObservableCollection<ViewSuShe_KaoQin>(list.Select(ss => (ViewSuShe_KaoQin)ss).ToList());
                        kqhide = Visibility.Hidden;

                    }
                    else
                    {
                        KQTipMsg = "并没有找到任何数据...";
                        kqhide = Visibility.Visible;
                    }
                }
                else
                {
                    KQTipMsg = "网络好像出现了异常...";
                    kqhide = Visibility.Visible;
                }
            }).ContinueWith(task =>
            {
                CanCloseDetail = true;
            });



        }
        public void LoadDatapf(Guid cid)
        {
            if (isfirstpf)
            {
                isfirstpf = false;
                return;
            }
            var serviceUrl = new Uri($"{Source}?DataType=pingfen&RoomID={cid}&NowTime={Par}");          
            Task.Run(() =>
            {
                pfhide = Visibility.Visible;
                PFTipMsg = "正在拉取数据...";
                CanCloseDetail = false;
                var result = Tools.Get(serviceUrl, out DashBoard.ServiceModel.SuShe_PingFen pingfen);
                if (result)
                {
                    PingFen = (ViewSuShe_PingFen)pingfen;
                    if (PingFen.msg!=null)
                    {                        
                        PF = new ObservableCollection<ViewPingFen>(PingFen.msg);
                        pfhide = Visibility.Hidden;
                    }
                    else
                    {
                        PFTipMsg = "并没有找到任何数据...";
                        pfhide = Visibility.Visible;
                    }
                }
                else
                {
                    PFTipMsg = "网络好像出现了异常...";
                    pfhide = Visibility.Visible;
                }
            }).ContinueWith(task =>
            {                                
                CanCloseDetail = true;
            });



        }
        private ObservableCollection<CustomDay> _Days;

        public ObservableCollection<CustomDay> Days
        {
            get { return _Days ?? (_Days = new ObservableCollection<CustomDay>()); }
            set
            {
                _Days = value;
                Application.Current.Dispatcher.BeginInvoke(new Action(() =>
                {
                    RaisePropertyChanged("Days");
                }));

            }
        }
        public class CustomDay : ObservableObject
        {
            private List<string> weeks = new List<string>() { "星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六" };
            public CustomDay(DateTime date)
            {
                WeekString = weeks[(int)date.DayOfWeek];
                if (date.Date == DateTime.Now.Date)
                {
                    DateString = "今天";
                }
                else
                {
                    DateString = date.ToString("MM-dd");
                }
                Date = date;
            }

            private string _WeekString;

            public string WeekString
            {
                get { return _WeekString; }
                set { _WeekString = value; RaisePropertyChanged("WeekString"); }
            }

            private string _DateString;

            public string DateString
            {
                get { return _DateString; }
                set { _DateString = value; RaisePropertyChanged("DateString"); }
            }

            private bool _IsSelected;

            public bool IsSelected
            {
                get { return _IsSelected; }
                set { _IsSelected = value; RaisePropertyChanged("IsSelected"); }
            }


            public DateTime Date { get; set; }
        }
        
    }

}
