﻿using GS.Terminal.DashBoard.Interface;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SchoolSituation.Environment
{
    [Export(typeof(IDashBoardPage))]
    /// <summary>
    /// Environment.xaml 的交互逻辑
    /// </summary>
    public partial class Environment : Page, IDashBoardPage
    {
        public Environment()
        {
            InitializeComponent();
        }

        public Guid PageID => new Guid("8a27048a-00ec-4906-8eb8-0fcd1d110436");

        public Uri Icon => new Uri("/SchoolSituation;component/images/icon-number.png", UriKind.Relative);

        public PageViewModel BindDataContext()
        {
            var vm = new EnvironmentViewModel();
            this.DataContext = vm;
            return vm;
        }

        public object Clone()
        {
            return new Environment() { DataContext = DataContext };
        }

        public void Dispose()
        {
            this.DataContext = null;
        }
    }
}
