﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GalaSoft.MvvmLight;

namespace SchoolSituation
{
    public class ViewClass_ClassNowEn : ObservableObject
    {
        private DateTime _UpdateTime;
        /// <summary>
        /// 最新刷新时间
        /// </summary>
        public DateTime UpdateTime
        {
            get { return _UpdateTime; }
            set { _UpdateTime = value; RaisePropertyChanged("UpdateTime"); }
        }
        private List<ViewClassEnvironmental> _ClassList;
        /// <summary>
        /// 班级信息
        /// </summary>
        public List<ViewClassEnvironmental> ClassList
        {
            get { return _ClassList; }
            set { _ClassList = value; RaisePropertyChanged("ClassList"); }
        }
        public static explicit operator ViewClass_ClassNowEn(DashBoard.ServiceModel.Class_ClassNowEn data)
        {
            var entity = new ViewClass_ClassNowEn();
            entity.UpdateTime = data.UpdateTime;
            entity.ClassList = data.ClassList.Select(r => (ViewClassEnvironmental)r).ToList();
            return entity;
        }
    }
    /// <summary>
    /// 班级单位信息
    /// </summary>
    public class ViewClassEnvironmental : ObservableObject
    {
        private int _ClassID;
        /// <summary>
        /// 班级编号
        /// </summary>
        public int ClassID
        {
            get { return _ClassID; }
            set { _ClassID = value; RaisePropertyChanged("ClassID"); }
        }
        private string _ClassName;
        /// <summary>
        /// 班级名称
        /// </summary>
        public string ClassName
        {
            get { return _ClassName; }
            set { _ClassName = value; RaisePropertyChanged("ClassName"); }
        }
        private string _RoomNumber;
        /// <summary>
        /// 教室编号
        /// </summary>
        public string RoomNumber
        {
            get { return _RoomNumber; }
            set { _RoomNumber = value; RaisePropertyChanged("RoomNumber"); }
        }
        private string _RoomName;
        /// <summary>
        /// 教室名称
        /// </summary>
        public string RoomName
        {
            get { return _RoomName; }
            set { _RoomName = value; RaisePropertyChanged("RoomName"); }
        }
        private decimal _ZaoSheng;
        /// <summary>
        /// 噪声
        /// </summary>
        public decimal ZaoSheng
        {
            get { return _ZaoSheng; }
            set { _ZaoSheng = value; RaisePropertyChanged("ZaoSheng"); }
        }
        private decimal _WenDu;
        /// <summary>
        /// 温度
        /// </summary>
        public decimal WenDu
        {
            get { return _WenDu; }
            set { _WenDu = value; RaisePropertyChanged("WenDu"); }
        }
        private decimal _ShiDu;
        /// <summary>
        /// 湿度
        /// </summary>
        public decimal ShiDu
        {
            get { return _ShiDu; }
            set { _ShiDu = value; RaisePropertyChanged("ShiDu"); }
        }
        private decimal _GuangZhao;
        /// <summary>
        /// 光照
        /// </summary>
        public decimal GuangZhao
        {
            get { return _GuangZhao; }
            set { _GuangZhao = value; RaisePropertyChanged("GuangZhao"); }
        }
        public static explicit operator ViewClassEnvironmental(DashBoard.ServiceModel.ClassEnvironmental data)
        {
            var entity = new ViewClassEnvironmental();
            entity.ClassID = data.ClassID;
            entity.ClassName = data.ClassName;
            entity.RoomName = data.RoomName;
            entity.RoomNumber = data.RoomNumber;
            entity.GuangZhao = data.GuangZhao;
            entity.ShiDu = data.ShiDu;
            entity.WenDu = data.WenDu;
            entity.ZaoSheng = data.ZaoSheng;
            return entity;
        }
    }

}
