﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GalaSoft.MvvmLight;

namespace SchoolSituation
{
    public class ViewSuSheState:ObservableObject
    {
        
        private int _FloorNumber;
        /// <summary>
        /// 楼层编号
        /// </summary>
        public int FloorNumber
        {
            get { return _FloorNumber; }
            set { _FloorNumber = value;RaisePropertyChanged("FloorNumber"); }
        }

        
        private List<ViewSuShe> _list;
        /// <summary>
        /// 楼层房间信息集合
        /// </summary>
        public List<ViewSuShe> list
        {
            get { return _list; }
            set { _list = value;RaisePropertyChanged("list"); }
        }
        public static explicit operator ViewSuSheState(DashBoard.ServiceModel.School_SuSheState data)
        {
            var entity = new ViewSuSheState();
            entity.FloorNumber = data.FloorNumber;
            entity.list = data.list.Select(r => (ViewSuShe)r).ToList();
            return entity;
        }

    }
    public class ViewSuShe: ObservableObject
    {
        /// <summary>
        /// 房间编号
        /// </summary>
        private Guid _RoomID;
        public Guid RoomID
        {
            get { return _RoomID; }
            set { _RoomID = value;RaisePropertyChanged("RoomID"); }
        }
        /// <summary>
        /// 房间名称
        /// </summary>
        private string _RoomName;
        public string RoomName
        {
            get { return _RoomName; }
            set { _RoomName = value;RaisePropertyChanged("RoomName"); }
        }
        /// <summary>
        /// 宿舍已安排人数
        /// </summary>
        private int _Sum;
        public int Sum
        {
            get { return _Sum; }
            set { _Sum = value;RaisePropertyChanged("Sum"); }
        }
        /// <summary>
        /// 在宿舍人数
        /// </summary>
        private int _In;
        public int In
        {
            get { return _In; }
            set { _In = value;RaisePropertyChanged("In"); }
        }
        public static explicit operator ViewSuShe(DashBoard.ServiceModel.SuShe data)
        {
            var entity = new ViewSuShe();
            entity.RoomID = data.RoomID;
            entity.RoomName = data.RoomName;
            entity.Sum = data.Sum;
            entity.In = data.In;
            return entity;
        }       
    }
    public class ViewSuShe_KaoQin : ObservableObject
    {
        /// <summary>
        /// 床位id
        /// </summary>
        private int _BidID;
        public int BidID { get { return _BidID; } set { _BidID = value; RaisePropertyChanged("BidID"); } }
        /// <summary>
        /// 床位编号
        /// </summary>
        private string _BidNumber;
        public string BidNumber
        {
            get { return _BidNumber; }
            set { _BidNumber = value; RaisePropertyChanged("BidNumber"); }
        }
        /// <summary>
        /// 学生id
        /// </summary>
        private int _StudentID;
        public int StudentID
        {
            get { return _StudentID; }
            set { _StudentID = value; RaisePropertyChanged("StudetnID"); }
        }
        /// <summary>
        /// 学生姓名
        /// </summary>
        private string _StudentName;
        public string StudentName
        {
            get { return _StudentName; }
            set { _StudentName = value; RaisePropertyChanged("StudentName"); }
        }
        /// <summary>
        /// 班级编号
        /// </summary>
        private Guid _ClassID;
        public Guid ClassID
        {
            get { return _ClassID; }
            set { _ClassID = value; RaisePropertyChanged("ClassID"); }
        }
        /// <summary>
        /// 班级名称
        /// </summary>
        private string _ClassName;
        public string ClassName
        {
            get { return _ClassName; }
            set { _ClassName = value; RaisePropertyChanged("ClassName"); }
        }
        /// <summary>
        /// 打卡时间
        /// </summary>
        private string _RecordTime;
        public string RecordTime
        {
            get { return _RecordTime; }
            set { _RecordTime = value; RaisePropertyChanged("RecordTime"); }
        }
        /// <summary>
        /// 考勤状态
        /// </summary>
        private string _State;
        public string State
        {
            get { return _State; }
            set { _State = value; RaisePropertyChanged("State"); }
        }
        public static explicit operator ViewSuShe_KaoQin(DashBoard.ServiceModel.SuShe_KaoQin data)
        {
            var entity = new ViewSuShe_KaoQin();
            entity.BidID = data.BidID;
            entity.BidNumber = data.BidNumber;
            entity.ClassID = data.ClassID;
            entity.ClassName = data.ClassName;
            entity.StudentID = data.StudentID;
            entity.StudentName = data.StudentName;
            entity.RecordTime = data.RecordTime;
            entity.State = data.State;
            return entity;
        }
    }
    public class ViewSuShe_PingFen:ObservableObject
    {
        private decimal _Sum;
        public decimal Sum
        {
            get { return _Sum; }
            set { _Sum = value;RaisePropertyChanged("Sum"); }
        }
        private List<ViewPingFen> _msg;
        public List<ViewPingFen> msg
        {
            get { return _msg; }
            set { _msg = value;RaisePropertyChanged("msg"); }
        }
        public static explicit operator ViewSuShe_PingFen(DashBoard.ServiceModel.SuShe_PingFen data)
        {
            var entity = new ViewSuShe_PingFen();
            entity.Sum = data.Sum;
            if(data.msg!=null)
            entity.msg = data.msg.Select(r => (ViewPingFen)r).ToList();
            return entity;
        }
    }
    public class ViewPingFen : ObservableObject
    {
        private decimal _ID;
        /// <summary>
        /// 评分ID
        /// </summary>
        public decimal ID
        {
            get { return _ID; }
            set { _ID = value; RaisePropertyChanged("ID"); }
        }
        private string _Obj;
        /// <summary>
        /// 评分对象
        /// </summary>
        public string Obj
        {
            get { return _Obj; }
            set { _Obj = value; RaisePropertyChanged("Obj"); }
        }
        private int _ProjectID;
        /// <summary>
        /// 评分类型ID
        /// </summary>
        public int ProjectID
        {
            get { return _ProjectID; }
            set { _ProjectID = value;RaisePropertyChanged("ProjectID"); }
        }
        private string _ProjectName;
        /// <summary>
        /// 评分类型名称
        /// </summary>
        public string ProjectName
        {
            get { return _ProjectName; }
            set { _ProjectName = value;RaisePropertyChanged("ProjectName"); }
        }
        private decimal _Score;
        /// <summary>
        /// 评分分值
        /// </summary>
        public decimal Score
        {
            get { return _Score; }
            set { _Score = value;RaisePropertyChanged("Score"); }
        }
        private int _ClassID;
        /// <summary>
        /// 评分班级ID
        /// </summary>
        public int ClassID
        {
            get { return _ClassID; }
            set { _ClassID = value;RaisePropertyChanged("ClassID"); }
        }
        /// <summary>
        /// 评分班级名称
        /// </summary>
        private string _ClassName;
        public string ClassName
        {
            get { return _ClassName; }
            set { _ClassName = value;RaisePropertyChanged("ClassName"); }
        }
        private string _Remark;
        /// <summary>
        /// 评分说明、备注
        /// </summary>
        public string Remark
        {
            get { return _Remark; }
            set { _Remark = value;RaisePropertyChanged("Remark"); }
        }
        public static explicit operator ViewPingFen(DashBoard.ServiceModel.PingFen data)
        {
            var entity = new ViewPingFen();
            entity.ID = data.ID;
            entity.Obj = data.Obj;
            entity.ProjectID = data.ProjectID;
            entity.ProjectName = data.ProjectName;
            entity.Score = data.Score;
            entity.ClassID = data.ClassID;
            entity.ClassName = data.ClassName;
            entity.Remark = data.Remark;
            return entity;
        }
    }
}
