﻿using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SchoolSituation
{
    
    public class ViewTeacherLeave: ObservableObject
    {

        private int _ID;
        public int ID
        {
            get { return _ID; }
            set { _ID = value; RaisePropertyChanged("ID"); }
        }

        /// <summary>
        /// 请假教师编号
        /// </summary>
        private string _TeacherID;
        public string TeacherID
        {
            get { return _TeacherID; }
            set { _TeacherID = value; RaisePropertyChanged("TeacherID"); }
        }
        /// <summary>
        /// 请假教师姓名
        /// </summary>
        private string _TeacherName;

        public string TeacherName
        {
            get { return _TeacherName; }
            set { _TeacherName = value; RaisePropertyChanged("TeacherName"); }
        }
        /// <summary>
        /// 请假类型
        /// </summary>
        private string _Type;
        public string Type
        {
            get { return _Type; }
            set { _Type = value; RaisePropertyChanged("Type"); }
        }
        /// <summary>
        /// 请假事由
        /// </summary>
        private string _Reason;
        public string Reason
        {
            get { return _Reason; }
            set { _Reason = value; RaisePropertyChanged("Reason"); }
        }
        /// <summary>
        /// 请假开始时间
        /// </summary>       
        private string _StartData;
        public string StartDate
        {
            get { return _StartData; }
            set { _StartData = value; RaisePropertyChanged("StartDate"); }
        }
        /// <summary>
        /// 请假结束时间
        /// </summary>
        private string _EndDate;
        public string EndDate
        {
            get { return _EndDate; }
            set { _EndDate = value; RaisePropertyChanged("EndDate"); }
        }
        /// <summary>
        /// 审核部门缩写编号
        /// </summary>
        private string _DeptNo;
        public string DeptNo
        {
            get { return _DeptNo; }
            set { _DeptNo = value; RaisePropertyChanged("DeptNo"); }
        }
        /// <summary>
        /// 审核部门名称
        /// </summary>
        private string _DeptName;
        public string DeptName
        {
            get { return _DeptName; }
            set { _DeptName = value; RaisePropertyChanged("DeptName"); }
        }
        public static explicit operator ViewTeacherLeave(DashBoard.ServiceModel.Leave data)
        {
            var entity = new ViewTeacherLeave();
            entity.TeacherName = data.TeacherName;
            entity.Type = data.Type;
            entity.StartDate = data.StartDate.ToString("MM-dd HH:mm");
            entity.EndDate = data.EndDate.ToString("MM-dd HH:mm");
            entity.DeptName = data.DeptName;
            entity.Reason = data.Reason;
            return entity;
        }
    }

}
