﻿using GS.Terminal.DashBoard.Interface;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Reflection;

namespace SchoolSituation
{
    public partial class StudentStateViewModel : PageViewModel
    {
        private ViewStudentState _StudentState;

        public ViewStudentState StudentState
        {
            get { return _StudentState; }
            set { _StudentState = value; RaisePropertyChanged("StudentState"); }
        }

        public override void Enter()
        {
            throw new NotImplementedException();
        }

        public override void Leave()
        {
            throw new NotImplementedException();
        }

        private bool isfirst = true;
        public override bool Update()
        {
            //是否第一次执行
            if (isfirst)
            {
                isfirst = false;
                var localresult = Tools.ReadCache($"StudentState.json");

                var local = JsonConvert.DeserializeObject<DashBoard.ServiceModel.School_StudentState>(localresult);
                if (local != null)
                {
                    StudentState = (ViewStudentState)local;
                }
            }

            //读取本地数据加载界面
            if (string.IsNullOrEmpty(Source)) return false;
            var updateResult = false;
            var getUrl = new Uri(Source);
            var result = Tools.Get(getUrl, out string backData);
            if (result)
            {
                var writeCacheResult = Tools.WriteCache($"StudentState.json", backData);
                if (writeCacheResult)//数据有更新，需要更新界面数据
                {
                    var entiy = JsonConvert.DeserializeObject<DashBoard.ServiceModel.School_StudentState>(backData);
                    StudentState = (ViewStudentState)entiy;
                    updateResult = true;
                }
                else//数据无更新
                {
                    updateResult = false;
                }
            }
            return updateResult;
        }
    }
}
